//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private JTRTape[] cacheJTRTape = null;
        private JTSTape[] cacheJTSTape = null;
        private JTStapeDepth[] cacheJTStapeDepth = null;

        private static JTRTape checkJTRTape = new JTRTape();
        private static JTSTape checkJTSTape = new JTSTape();
        private static JTStapeDepth checkJTStapeDepth = new JTStapeDepth();

        /// <summary>
        /// JTRTape
        /// </summary>
        /// <returns></returns>
        public JTRTape JTRTape(Color aboveAskBackColor, Color aboveAskColor, bool alwaysOnTop, int askPosision, Color atAskBackColor, Color atAskColor, Color atBidBackColor, Color atBidColor, Color belowBidBackColor, Color belowBidColor, Color betweenBackColor, Color betweenColor, int bidPosision, ConsolidationMode cMode, int columnSpacing, int condPosition, bool hLSession, int leastSignificantDigits, int numRows, PrintMode pMode, int pricePosition, bool reverseHighLow, long sensitivity, int sizeFilter, Color sweepAskBackColor, Color sweepAskColor, Color sweepBidBackColor, Color sweepBidColor, bool sweepColors, Font textFont, int timePosition, Algorithm useAlgorithm, int volPosition)
        {
            return JTRTape(Input, aboveAskBackColor, aboveAskColor, alwaysOnTop, askPosision, atAskBackColor, atAskColor, atBidBackColor, atBidColor, belowBidBackColor, belowBidColor, betweenBackColor, betweenColor, bidPosision, cMode, columnSpacing, condPosition, hLSession, leastSignificantDigits, numRows, pMode, pricePosition, reverseHighLow, sensitivity, sizeFilter, sweepAskBackColor, sweepAskColor, sweepBidBackColor, sweepBidColor, sweepColors, textFont, timePosition, useAlgorithm, volPosition);
        }

        /// <summary>
        /// JTRTape
        /// </summary>
        /// <returns></returns>
        public JTRTape JTRTape(Data.IDataSeries input, Color aboveAskBackColor, Color aboveAskColor, bool alwaysOnTop, int askPosision, Color atAskBackColor, Color atAskColor, Color atBidBackColor, Color atBidColor, Color belowBidBackColor, Color belowBidColor, Color betweenBackColor, Color betweenColor, int bidPosision, ConsolidationMode cMode, int columnSpacing, int condPosition, bool hLSession, int leastSignificantDigits, int numRows, PrintMode pMode, int pricePosition, bool reverseHighLow, long sensitivity, int sizeFilter, Color sweepAskBackColor, Color sweepAskColor, Color sweepBidBackColor, Color sweepBidColor, bool sweepColors, Font textFont, int timePosition, Algorithm useAlgorithm, int volPosition)
        {
            if (cacheJTRTape != null)
                for (int idx = 0; idx < cacheJTRTape.Length; idx++)
                    if (cacheJTRTape[idx].AboveAskBackColor == aboveAskBackColor && cacheJTRTape[idx].AboveAskColor == aboveAskColor && cacheJTRTape[idx].AlwaysOnTop == alwaysOnTop && cacheJTRTape[idx].AskPosision == askPosision && cacheJTRTape[idx].AtAskBackColor == atAskBackColor && cacheJTRTape[idx].AtAskColor == atAskColor && cacheJTRTape[idx].AtBidBackColor == atBidBackColor && cacheJTRTape[idx].AtBidColor == atBidColor && cacheJTRTape[idx].BelowBidBackColor == belowBidBackColor && cacheJTRTape[idx].BelowBidColor == belowBidColor && cacheJTRTape[idx].BetweenBackColor == betweenBackColor && cacheJTRTape[idx].BetweenColor == betweenColor && cacheJTRTape[idx].BidPosision == bidPosision && cacheJTRTape[idx].CMode == cMode && cacheJTRTape[idx].ColumnSpacing == columnSpacing && cacheJTRTape[idx].CondPosition == condPosition && cacheJTRTape[idx].HLSession == hLSession && cacheJTRTape[idx].LeastSignificantDigits == leastSignificantDigits && cacheJTRTape[idx].NumRows == numRows && cacheJTRTape[idx].PMode == pMode && cacheJTRTape[idx].PricePosition == pricePosition && cacheJTRTape[idx].ReverseHighLow == reverseHighLow && cacheJTRTape[idx].Sensitivity == sensitivity && cacheJTRTape[idx].SizeFilter == sizeFilter && cacheJTRTape[idx].SweepAskBackColor == sweepAskBackColor && cacheJTRTape[idx].SweepAskColor == sweepAskColor && cacheJTRTape[idx].SweepBidBackColor == sweepBidBackColor && cacheJTRTape[idx].SweepBidColor == sweepBidColor && cacheJTRTape[idx].SweepColors == sweepColors && cacheJTRTape[idx].TextFont == textFont && cacheJTRTape[idx].TimePosition == timePosition && cacheJTRTape[idx].UseAlgorithm == useAlgorithm && cacheJTRTape[idx].VolPosition == volPosition && cacheJTRTape[idx].EqualsInput(input))
                        return cacheJTRTape[idx];

            lock (checkJTRTape)
            {
                checkJTRTape.AboveAskBackColor = aboveAskBackColor;
                aboveAskBackColor = checkJTRTape.AboveAskBackColor;
                checkJTRTape.AboveAskColor = aboveAskColor;
                aboveAskColor = checkJTRTape.AboveAskColor;
                checkJTRTape.AlwaysOnTop = alwaysOnTop;
                alwaysOnTop = checkJTRTape.AlwaysOnTop;
                checkJTRTape.AskPosision = askPosision;
                askPosision = checkJTRTape.AskPosision;
                checkJTRTape.AtAskBackColor = atAskBackColor;
                atAskBackColor = checkJTRTape.AtAskBackColor;
                checkJTRTape.AtAskColor = atAskColor;
                atAskColor = checkJTRTape.AtAskColor;
                checkJTRTape.AtBidBackColor = atBidBackColor;
                atBidBackColor = checkJTRTape.AtBidBackColor;
                checkJTRTape.AtBidColor = atBidColor;
                atBidColor = checkJTRTape.AtBidColor;
                checkJTRTape.BelowBidBackColor = belowBidBackColor;
                belowBidBackColor = checkJTRTape.BelowBidBackColor;
                checkJTRTape.BelowBidColor = belowBidColor;
                belowBidColor = checkJTRTape.BelowBidColor;
                checkJTRTape.BetweenBackColor = betweenBackColor;
                betweenBackColor = checkJTRTape.BetweenBackColor;
                checkJTRTape.BetweenColor = betweenColor;
                betweenColor = checkJTRTape.BetweenColor;
                checkJTRTape.BidPosision = bidPosision;
                bidPosision = checkJTRTape.BidPosision;
                checkJTRTape.CMode = cMode;
                cMode = checkJTRTape.CMode;
                checkJTRTape.ColumnSpacing = columnSpacing;
                columnSpacing = checkJTRTape.ColumnSpacing;
                checkJTRTape.CondPosition = condPosition;
                condPosition = checkJTRTape.CondPosition;
                checkJTRTape.HLSession = hLSession;
                hLSession = checkJTRTape.HLSession;
                checkJTRTape.LeastSignificantDigits = leastSignificantDigits;
                leastSignificantDigits = checkJTRTape.LeastSignificantDigits;
                checkJTRTape.NumRows = numRows;
                numRows = checkJTRTape.NumRows;
                checkJTRTape.PMode = pMode;
                pMode = checkJTRTape.PMode;
                checkJTRTape.PricePosition = pricePosition;
                pricePosition = checkJTRTape.PricePosition;
                checkJTRTape.ReverseHighLow = reverseHighLow;
                reverseHighLow = checkJTRTape.ReverseHighLow;
                checkJTRTape.Sensitivity = sensitivity;
                sensitivity = checkJTRTape.Sensitivity;
                checkJTRTape.SizeFilter = sizeFilter;
                sizeFilter = checkJTRTape.SizeFilter;
                checkJTRTape.SweepAskBackColor = sweepAskBackColor;
                sweepAskBackColor = checkJTRTape.SweepAskBackColor;
                checkJTRTape.SweepAskColor = sweepAskColor;
                sweepAskColor = checkJTRTape.SweepAskColor;
                checkJTRTape.SweepBidBackColor = sweepBidBackColor;
                sweepBidBackColor = checkJTRTape.SweepBidBackColor;
                checkJTRTape.SweepBidColor = sweepBidColor;
                sweepBidColor = checkJTRTape.SweepBidColor;
                checkJTRTape.SweepColors = sweepColors;
                sweepColors = checkJTRTape.SweepColors;
                checkJTRTape.TextFont = textFont;
                textFont = checkJTRTape.TextFont;
                checkJTRTape.TimePosition = timePosition;
                timePosition = checkJTRTape.TimePosition;
                checkJTRTape.UseAlgorithm = useAlgorithm;
                useAlgorithm = checkJTRTape.UseAlgorithm;
                checkJTRTape.VolPosition = volPosition;
                volPosition = checkJTRTape.VolPosition;

                if (cacheJTRTape != null)
                    for (int idx = 0; idx < cacheJTRTape.Length; idx++)
                        if (cacheJTRTape[idx].AboveAskBackColor == aboveAskBackColor && cacheJTRTape[idx].AboveAskColor == aboveAskColor && cacheJTRTape[idx].AlwaysOnTop == alwaysOnTop && cacheJTRTape[idx].AskPosision == askPosision && cacheJTRTape[idx].AtAskBackColor == atAskBackColor && cacheJTRTape[idx].AtAskColor == atAskColor && cacheJTRTape[idx].AtBidBackColor == atBidBackColor && cacheJTRTape[idx].AtBidColor == atBidColor && cacheJTRTape[idx].BelowBidBackColor == belowBidBackColor && cacheJTRTape[idx].BelowBidColor == belowBidColor && cacheJTRTape[idx].BetweenBackColor == betweenBackColor && cacheJTRTape[idx].BetweenColor == betweenColor && cacheJTRTape[idx].BidPosision == bidPosision && cacheJTRTape[idx].CMode == cMode && cacheJTRTape[idx].ColumnSpacing == columnSpacing && cacheJTRTape[idx].CondPosition == condPosition && cacheJTRTape[idx].HLSession == hLSession && cacheJTRTape[idx].LeastSignificantDigits == leastSignificantDigits && cacheJTRTape[idx].NumRows == numRows && cacheJTRTape[idx].PMode == pMode && cacheJTRTape[idx].PricePosition == pricePosition && cacheJTRTape[idx].ReverseHighLow == reverseHighLow && cacheJTRTape[idx].Sensitivity == sensitivity && cacheJTRTape[idx].SizeFilter == sizeFilter && cacheJTRTape[idx].SweepAskBackColor == sweepAskBackColor && cacheJTRTape[idx].SweepAskColor == sweepAskColor && cacheJTRTape[idx].SweepBidBackColor == sweepBidBackColor && cacheJTRTape[idx].SweepBidColor == sweepBidColor && cacheJTRTape[idx].SweepColors == sweepColors && cacheJTRTape[idx].TextFont == textFont && cacheJTRTape[idx].TimePosition == timePosition && cacheJTRTape[idx].UseAlgorithm == useAlgorithm && cacheJTRTape[idx].VolPosition == volPosition && cacheJTRTape[idx].EqualsInput(input))
                            return cacheJTRTape[idx];

                JTRTape indicator = new JTRTape();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.AboveAskBackColor = aboveAskBackColor;
                indicator.AboveAskColor = aboveAskColor;
                indicator.AlwaysOnTop = alwaysOnTop;
                indicator.AskPosision = askPosision;
                indicator.AtAskBackColor = atAskBackColor;
                indicator.AtAskColor = atAskColor;
                indicator.AtBidBackColor = atBidBackColor;
                indicator.AtBidColor = atBidColor;
                indicator.BelowBidBackColor = belowBidBackColor;
                indicator.BelowBidColor = belowBidColor;
                indicator.BetweenBackColor = betweenBackColor;
                indicator.BetweenColor = betweenColor;
                indicator.BidPosision = bidPosision;
                indicator.CMode = cMode;
                indicator.ColumnSpacing = columnSpacing;
                indicator.CondPosition = condPosition;
                indicator.HLSession = hLSession;
                indicator.LeastSignificantDigits = leastSignificantDigits;
                indicator.NumRows = numRows;
                indicator.PMode = pMode;
                indicator.PricePosition = pricePosition;
                indicator.ReverseHighLow = reverseHighLow;
                indicator.Sensitivity = sensitivity;
                indicator.SizeFilter = sizeFilter;
                indicator.SweepAskBackColor = sweepAskBackColor;
                indicator.SweepAskColor = sweepAskColor;
                indicator.SweepBidBackColor = sweepBidBackColor;
                indicator.SweepBidColor = sweepBidColor;
                indicator.SweepColors = sweepColors;
                indicator.TextFont = textFont;
                indicator.TimePosition = timePosition;
                indicator.UseAlgorithm = useAlgorithm;
                indicator.VolPosition = volPosition;
                Indicators.Add(indicator);
                indicator.SetUp();

                JTRTape[] tmp = new JTRTape[cacheJTRTape == null ? 1 : cacheJTRTape.Length + 1];
                if (cacheJTRTape != null)
                    cacheJTRTape.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheJTRTape = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// JTSummaryTape
        /// </summary>
        /// <returns></returns>
        public JTSTape JTSTape(bool alwaysOnTop, string askIcebergAlertWav, Color askIcebergColor, string askLargeQtyAlertWav, Color askLargeQtyColor, Color backgroundColor, string bearDivAlertWav, Color bearishDivergenceColor, string bidIcebergAlertWav, Color bidIcebergColor, string bidLargeQtyAlertWav, Color bidLargeQtyColor, string bullDivAlertWav, Color bullishDivergenceColor, int columnSpacing, Color currentColor, int depthMult, int divAlertMin, bool divergenceAlert, Color downTickColor, DeltaType dType, int iceberAlertMinQty, bool icebergAlert, bool largeQtyAlert, int largeQtyMin, int leastSignificantDigits, int numRows, bool plotDivergence, bool plotIceberg, bool plotLargeQty, Font textFont, Color upTickColor)
        {
            return JTSTape(Input, alwaysOnTop, askIcebergAlertWav, askIcebergColor, askLargeQtyAlertWav, askLargeQtyColor, backgroundColor, bearDivAlertWav, bearishDivergenceColor, bidIcebergAlertWav, bidIcebergColor, bidLargeQtyAlertWav, bidLargeQtyColor, bullDivAlertWav, bullishDivergenceColor, columnSpacing, currentColor, depthMult, divAlertMin, divergenceAlert, downTickColor, dType, iceberAlertMinQty, icebergAlert, largeQtyAlert, largeQtyMin, leastSignificantDigits, numRows, plotDivergence, plotIceberg, plotLargeQty, textFont, upTickColor);
        }

        /// <summary>
        /// JTSummaryTape
        /// </summary>
        /// <returns></returns>
        public JTSTape JTSTape(Data.IDataSeries input, bool alwaysOnTop, string askIcebergAlertWav, Color askIcebergColor, string askLargeQtyAlertWav, Color askLargeQtyColor, Color backgroundColor, string bearDivAlertWav, Color bearishDivergenceColor, string bidIcebergAlertWav, Color bidIcebergColor, string bidLargeQtyAlertWav, Color bidLargeQtyColor, string bullDivAlertWav, Color bullishDivergenceColor, int columnSpacing, Color currentColor, int depthMult, int divAlertMin, bool divergenceAlert, Color downTickColor, DeltaType dType, int iceberAlertMinQty, bool icebergAlert, bool largeQtyAlert, int largeQtyMin, int leastSignificantDigits, int numRows, bool plotDivergence, bool plotIceberg, bool plotLargeQty, Font textFont, Color upTickColor)
        {
            if (cacheJTSTape != null)
                for (int idx = 0; idx < cacheJTSTape.Length; idx++)
                    if (cacheJTSTape[idx].AlwaysOnTop == alwaysOnTop && cacheJTSTape[idx].AskIcebergAlertWav == askIcebergAlertWav && cacheJTSTape[idx].AskIcebergColor == askIcebergColor && cacheJTSTape[idx].AskLargeQtyAlertWav == askLargeQtyAlertWav && cacheJTSTape[idx].AskLargeQtyColor == askLargeQtyColor && cacheJTSTape[idx].BackgroundColor == backgroundColor && cacheJTSTape[idx].BearDivAlertWav == bearDivAlertWav && cacheJTSTape[idx].BearishDivergenceColor == bearishDivergenceColor && cacheJTSTape[idx].BidIcebergAlertWav == bidIcebergAlertWav && cacheJTSTape[idx].BidIcebergColor == bidIcebergColor && cacheJTSTape[idx].BidLargeQtyAlertWav == bidLargeQtyAlertWav && cacheJTSTape[idx].BidLargeQtyColor == bidLargeQtyColor && cacheJTSTape[idx].BullDivAlertWav == bullDivAlertWav && cacheJTSTape[idx].BullishDivergenceColor == bullishDivergenceColor && cacheJTSTape[idx].ColumnSpacing == columnSpacing && cacheJTSTape[idx].CurrentColor == currentColor && cacheJTSTape[idx].DepthMult == depthMult && cacheJTSTape[idx].DivAlertMin == divAlertMin && cacheJTSTape[idx].DivergenceAlert == divergenceAlert && cacheJTSTape[idx].DownTickColor == downTickColor && cacheJTSTape[idx].DType == dType && cacheJTSTape[idx].IceberAlertMinQty == iceberAlertMinQty && cacheJTSTape[idx].IcebergAlert == icebergAlert && cacheJTSTape[idx].LargeQtyAlert == largeQtyAlert && cacheJTSTape[idx].LargeQtyMin == largeQtyMin && cacheJTSTape[idx].LeastSignificantDigits == leastSignificantDigits && cacheJTSTape[idx].NumRows == numRows && cacheJTSTape[idx].PlotDivergence == plotDivergence && cacheJTSTape[idx].PlotIceberg == plotIceberg && cacheJTSTape[idx].PlotLargeQty == plotLargeQty && cacheJTSTape[idx].TextFont == textFont && cacheJTSTape[idx].UpTickColor == upTickColor && cacheJTSTape[idx].EqualsInput(input))
                        return cacheJTSTape[idx];

            lock (checkJTSTape)
            {
                checkJTSTape.AlwaysOnTop = alwaysOnTop;
                alwaysOnTop = checkJTSTape.AlwaysOnTop;
                checkJTSTape.AskIcebergAlertWav = askIcebergAlertWav;
                askIcebergAlertWav = checkJTSTape.AskIcebergAlertWav;
                checkJTSTape.AskIcebergColor = askIcebergColor;
                askIcebergColor = checkJTSTape.AskIcebergColor;
                checkJTSTape.AskLargeQtyAlertWav = askLargeQtyAlertWav;
                askLargeQtyAlertWav = checkJTSTape.AskLargeQtyAlertWav;
                checkJTSTape.AskLargeQtyColor = askLargeQtyColor;
                askLargeQtyColor = checkJTSTape.AskLargeQtyColor;
                checkJTSTape.BackgroundColor = backgroundColor;
                backgroundColor = checkJTSTape.BackgroundColor;
                checkJTSTape.BearDivAlertWav = bearDivAlertWav;
                bearDivAlertWav = checkJTSTape.BearDivAlertWav;
                checkJTSTape.BearishDivergenceColor = bearishDivergenceColor;
                bearishDivergenceColor = checkJTSTape.BearishDivergenceColor;
                checkJTSTape.BidIcebergAlertWav = bidIcebergAlertWav;
                bidIcebergAlertWav = checkJTSTape.BidIcebergAlertWav;
                checkJTSTape.BidIcebergColor = bidIcebergColor;
                bidIcebergColor = checkJTSTape.BidIcebergColor;
                checkJTSTape.BidLargeQtyAlertWav = bidLargeQtyAlertWav;
                bidLargeQtyAlertWav = checkJTSTape.BidLargeQtyAlertWav;
                checkJTSTape.BidLargeQtyColor = bidLargeQtyColor;
                bidLargeQtyColor = checkJTSTape.BidLargeQtyColor;
                checkJTSTape.BullDivAlertWav = bullDivAlertWav;
                bullDivAlertWav = checkJTSTape.BullDivAlertWav;
                checkJTSTape.BullishDivergenceColor = bullishDivergenceColor;
                bullishDivergenceColor = checkJTSTape.BullishDivergenceColor;
                checkJTSTape.ColumnSpacing = columnSpacing;
                columnSpacing = checkJTSTape.ColumnSpacing;
                checkJTSTape.CurrentColor = currentColor;
                currentColor = checkJTSTape.CurrentColor;
                checkJTSTape.DepthMult = depthMult;
                depthMult = checkJTSTape.DepthMult;
                checkJTSTape.DivAlertMin = divAlertMin;
                divAlertMin = checkJTSTape.DivAlertMin;
                checkJTSTape.DivergenceAlert = divergenceAlert;
                divergenceAlert = checkJTSTape.DivergenceAlert;
                checkJTSTape.DownTickColor = downTickColor;
                downTickColor = checkJTSTape.DownTickColor;
                checkJTSTape.DType = dType;
                dType = checkJTSTape.DType;
                checkJTSTape.IceberAlertMinQty = iceberAlertMinQty;
                iceberAlertMinQty = checkJTSTape.IceberAlertMinQty;
                checkJTSTape.IcebergAlert = icebergAlert;
                icebergAlert = checkJTSTape.IcebergAlert;
                checkJTSTape.LargeQtyAlert = largeQtyAlert;
                largeQtyAlert = checkJTSTape.LargeQtyAlert;
                checkJTSTape.LargeQtyMin = largeQtyMin;
                largeQtyMin = checkJTSTape.LargeQtyMin;
                checkJTSTape.LeastSignificantDigits = leastSignificantDigits;
                leastSignificantDigits = checkJTSTape.LeastSignificantDigits;
                checkJTSTape.NumRows = numRows;
                numRows = checkJTSTape.NumRows;
                checkJTSTape.PlotDivergence = plotDivergence;
                plotDivergence = checkJTSTape.PlotDivergence;
                checkJTSTape.PlotIceberg = plotIceberg;
                plotIceberg = checkJTSTape.PlotIceberg;
                checkJTSTape.PlotLargeQty = plotLargeQty;
                plotLargeQty = checkJTSTape.PlotLargeQty;
                checkJTSTape.TextFont = textFont;
                textFont = checkJTSTape.TextFont;
                checkJTSTape.UpTickColor = upTickColor;
                upTickColor = checkJTSTape.UpTickColor;

                if (cacheJTSTape != null)
                    for (int idx = 0; idx < cacheJTSTape.Length; idx++)
                        if (cacheJTSTape[idx].AlwaysOnTop == alwaysOnTop && cacheJTSTape[idx].AskIcebergAlertWav == askIcebergAlertWav && cacheJTSTape[idx].AskIcebergColor == askIcebergColor && cacheJTSTape[idx].AskLargeQtyAlertWav == askLargeQtyAlertWav && cacheJTSTape[idx].AskLargeQtyColor == askLargeQtyColor && cacheJTSTape[idx].BackgroundColor == backgroundColor && cacheJTSTape[idx].BearDivAlertWav == bearDivAlertWav && cacheJTSTape[idx].BearishDivergenceColor == bearishDivergenceColor && cacheJTSTape[idx].BidIcebergAlertWav == bidIcebergAlertWav && cacheJTSTape[idx].BidIcebergColor == bidIcebergColor && cacheJTSTape[idx].BidLargeQtyAlertWav == bidLargeQtyAlertWav && cacheJTSTape[idx].BidLargeQtyColor == bidLargeQtyColor && cacheJTSTape[idx].BullDivAlertWav == bullDivAlertWav && cacheJTSTape[idx].BullishDivergenceColor == bullishDivergenceColor && cacheJTSTape[idx].ColumnSpacing == columnSpacing && cacheJTSTape[idx].CurrentColor == currentColor && cacheJTSTape[idx].DepthMult == depthMult && cacheJTSTape[idx].DivAlertMin == divAlertMin && cacheJTSTape[idx].DivergenceAlert == divergenceAlert && cacheJTSTape[idx].DownTickColor == downTickColor && cacheJTSTape[idx].DType == dType && cacheJTSTape[idx].IceberAlertMinQty == iceberAlertMinQty && cacheJTSTape[idx].IcebergAlert == icebergAlert && cacheJTSTape[idx].LargeQtyAlert == largeQtyAlert && cacheJTSTape[idx].LargeQtyMin == largeQtyMin && cacheJTSTape[idx].LeastSignificantDigits == leastSignificantDigits && cacheJTSTape[idx].NumRows == numRows && cacheJTSTape[idx].PlotDivergence == plotDivergence && cacheJTSTape[idx].PlotIceberg == plotIceberg && cacheJTSTape[idx].PlotLargeQty == plotLargeQty && cacheJTSTape[idx].TextFont == textFont && cacheJTSTape[idx].UpTickColor == upTickColor && cacheJTSTape[idx].EqualsInput(input))
                            return cacheJTSTape[idx];

                JTSTape indicator = new JTSTape();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.AlwaysOnTop = alwaysOnTop;
                indicator.AskIcebergAlertWav = askIcebergAlertWav;
                indicator.AskIcebergColor = askIcebergColor;
                indicator.AskLargeQtyAlertWav = askLargeQtyAlertWav;
                indicator.AskLargeQtyColor = askLargeQtyColor;
                indicator.BackgroundColor = backgroundColor;
                indicator.BearDivAlertWav = bearDivAlertWav;
                indicator.BearishDivergenceColor = bearishDivergenceColor;
                indicator.BidIcebergAlertWav = bidIcebergAlertWav;
                indicator.BidIcebergColor = bidIcebergColor;
                indicator.BidLargeQtyAlertWav = bidLargeQtyAlertWav;
                indicator.BidLargeQtyColor = bidLargeQtyColor;
                indicator.BullDivAlertWav = bullDivAlertWav;
                indicator.BullishDivergenceColor = bullishDivergenceColor;
                indicator.ColumnSpacing = columnSpacing;
                indicator.CurrentColor = currentColor;
                indicator.DepthMult = depthMult;
                indicator.DivAlertMin = divAlertMin;
                indicator.DivergenceAlert = divergenceAlert;
                indicator.DownTickColor = downTickColor;
                indicator.DType = dType;
                indicator.IceberAlertMinQty = iceberAlertMinQty;
                indicator.IcebergAlert = icebergAlert;
                indicator.LargeQtyAlert = largeQtyAlert;
                indicator.LargeQtyMin = largeQtyMin;
                indicator.LeastSignificantDigits = leastSignificantDigits;
                indicator.NumRows = numRows;
                indicator.PlotDivergence = plotDivergence;
                indicator.PlotIceberg = plotIceberg;
                indicator.PlotLargeQty = plotLargeQty;
                indicator.TextFont = textFont;
                indicator.UpTickColor = upTickColor;
                Indicators.Add(indicator);
                indicator.SetUp();

                JTSTape[] tmp = new JTSTape[cacheJTSTape == null ? 1 : cacheJTSTape.Length + 1];
                if (cacheJTSTape != null)
                    cacheJTSTape.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheJTSTape = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// JTSummaryTape Depth
        /// </summary>
        /// <returns></returns>
        public JTStapeDepth JTStapeDepth(bool alwaysOnTop, Color backgroundColor, Color currentColor, Color downTickColor, int leastSignificantDigits, int numRows, Font textFont, Color upTickColor)
        {
            return JTStapeDepth(Input, alwaysOnTop, backgroundColor, currentColor, downTickColor, leastSignificantDigits, numRows, textFont, upTickColor);
        }

        /// <summary>
        /// JTSummaryTape Depth
        /// </summary>
        /// <returns></returns>
        public JTStapeDepth JTStapeDepth(Data.IDataSeries input, bool alwaysOnTop, Color backgroundColor, Color currentColor, Color downTickColor, int leastSignificantDigits, int numRows, Font textFont, Color upTickColor)
        {
            if (cacheJTStapeDepth != null)
                for (int idx = 0; idx < cacheJTStapeDepth.Length; idx++)
                    if (cacheJTStapeDepth[idx].AlwaysOnTop == alwaysOnTop && cacheJTStapeDepth[idx].BackgroundColor == backgroundColor && cacheJTStapeDepth[idx].CurrentColor == currentColor && cacheJTStapeDepth[idx].DownTickColor == downTickColor && cacheJTStapeDepth[idx].LeastSignificantDigits == leastSignificantDigits && cacheJTStapeDepth[idx].NumRows == numRows && cacheJTStapeDepth[idx].TextFont == textFont && cacheJTStapeDepth[idx].UpTickColor == upTickColor && cacheJTStapeDepth[idx].EqualsInput(input))
                        return cacheJTStapeDepth[idx];

            lock (checkJTStapeDepth)
            {
                checkJTStapeDepth.AlwaysOnTop = alwaysOnTop;
                alwaysOnTop = checkJTStapeDepth.AlwaysOnTop;
                checkJTStapeDepth.BackgroundColor = backgroundColor;
                backgroundColor = checkJTStapeDepth.BackgroundColor;
                checkJTStapeDepth.CurrentColor = currentColor;
                currentColor = checkJTStapeDepth.CurrentColor;
                checkJTStapeDepth.DownTickColor = downTickColor;
                downTickColor = checkJTStapeDepth.DownTickColor;
                checkJTStapeDepth.LeastSignificantDigits = leastSignificantDigits;
                leastSignificantDigits = checkJTStapeDepth.LeastSignificantDigits;
                checkJTStapeDepth.NumRows = numRows;
                numRows = checkJTStapeDepth.NumRows;
                checkJTStapeDepth.TextFont = textFont;
                textFont = checkJTStapeDepth.TextFont;
                checkJTStapeDepth.UpTickColor = upTickColor;
                upTickColor = checkJTStapeDepth.UpTickColor;

                if (cacheJTStapeDepth != null)
                    for (int idx = 0; idx < cacheJTStapeDepth.Length; idx++)
                        if (cacheJTStapeDepth[idx].AlwaysOnTop == alwaysOnTop && cacheJTStapeDepth[idx].BackgroundColor == backgroundColor && cacheJTStapeDepth[idx].CurrentColor == currentColor && cacheJTStapeDepth[idx].DownTickColor == downTickColor && cacheJTStapeDepth[idx].LeastSignificantDigits == leastSignificantDigits && cacheJTStapeDepth[idx].NumRows == numRows && cacheJTStapeDepth[idx].TextFont == textFont && cacheJTStapeDepth[idx].UpTickColor == upTickColor && cacheJTStapeDepth[idx].EqualsInput(input))
                            return cacheJTStapeDepth[idx];

                JTStapeDepth indicator = new JTStapeDepth();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.AlwaysOnTop = alwaysOnTop;
                indicator.BackgroundColor = backgroundColor;
                indicator.CurrentColor = currentColor;
                indicator.DownTickColor = downTickColor;
                indicator.LeastSignificantDigits = leastSignificantDigits;
                indicator.NumRows = numRows;
                indicator.TextFont = textFont;
                indicator.UpTickColor = upTickColor;
                Indicators.Add(indicator);
                indicator.SetUp();

                JTStapeDepth[] tmp = new JTStapeDepth[cacheJTStapeDepth == null ? 1 : cacheJTStapeDepth.Length + 1];
                if (cacheJTStapeDepth != null)
                    cacheJTStapeDepth.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheJTStapeDepth = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// JTRTape
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.JTRTape JTRTape(Color aboveAskBackColor, Color aboveAskColor, bool alwaysOnTop, int askPosision, Color atAskBackColor, Color atAskColor, Color atBidBackColor, Color atBidColor, Color belowBidBackColor, Color belowBidColor, Color betweenBackColor, Color betweenColor, int bidPosision, ConsolidationMode cMode, int columnSpacing, int condPosition, bool hLSession, int leastSignificantDigits, int numRows, PrintMode pMode, int pricePosition, bool reverseHighLow, long sensitivity, int sizeFilter, Color sweepAskBackColor, Color sweepAskColor, Color sweepBidBackColor, Color sweepBidColor, bool sweepColors, Font textFont, int timePosition, Algorithm useAlgorithm, int volPosition)
        {
            return _indicator.JTRTape(Input, aboveAskBackColor, aboveAskColor, alwaysOnTop, askPosision, atAskBackColor, atAskColor, atBidBackColor, atBidColor, belowBidBackColor, belowBidColor, betweenBackColor, betweenColor, bidPosision, cMode, columnSpacing, condPosition, hLSession, leastSignificantDigits, numRows, pMode, pricePosition, reverseHighLow, sensitivity, sizeFilter, sweepAskBackColor, sweepAskColor, sweepBidBackColor, sweepBidColor, sweepColors, textFont, timePosition, useAlgorithm, volPosition);
        }

        /// <summary>
        /// JTRTape
        /// </summary>
        /// <returns></returns>
        public Indicator.JTRTape JTRTape(Data.IDataSeries input, Color aboveAskBackColor, Color aboveAskColor, bool alwaysOnTop, int askPosision, Color atAskBackColor, Color atAskColor, Color atBidBackColor, Color atBidColor, Color belowBidBackColor, Color belowBidColor, Color betweenBackColor, Color betweenColor, int bidPosision, ConsolidationMode cMode, int columnSpacing, int condPosition, bool hLSession, int leastSignificantDigits, int numRows, PrintMode pMode, int pricePosition, bool reverseHighLow, long sensitivity, int sizeFilter, Color sweepAskBackColor, Color sweepAskColor, Color sweepBidBackColor, Color sweepBidColor, bool sweepColors, Font textFont, int timePosition, Algorithm useAlgorithm, int volPosition)
        {
            return _indicator.JTRTape(input, aboveAskBackColor, aboveAskColor, alwaysOnTop, askPosision, atAskBackColor, atAskColor, atBidBackColor, atBidColor, belowBidBackColor, belowBidColor, betweenBackColor, betweenColor, bidPosision, cMode, columnSpacing, condPosition, hLSession, leastSignificantDigits, numRows, pMode, pricePosition, reverseHighLow, sensitivity, sizeFilter, sweepAskBackColor, sweepAskColor, sweepBidBackColor, sweepBidColor, sweepColors, textFont, timePosition, useAlgorithm, volPosition);
        }

        /// <summary>
        /// JTSummaryTape
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.JTSTape JTSTape(bool alwaysOnTop, string askIcebergAlertWav, Color askIcebergColor, string askLargeQtyAlertWav, Color askLargeQtyColor, Color backgroundColor, string bearDivAlertWav, Color bearishDivergenceColor, string bidIcebergAlertWav, Color bidIcebergColor, string bidLargeQtyAlertWav, Color bidLargeQtyColor, string bullDivAlertWav, Color bullishDivergenceColor, int columnSpacing, Color currentColor, int depthMult, int divAlertMin, bool divergenceAlert, Color downTickColor, DeltaType dType, int iceberAlertMinQty, bool icebergAlert, bool largeQtyAlert, int largeQtyMin, int leastSignificantDigits, int numRows, bool plotDivergence, bool plotIceberg, bool plotLargeQty, Font textFont, Color upTickColor)
        {
            return _indicator.JTSTape(Input, alwaysOnTop, askIcebergAlertWav, askIcebergColor, askLargeQtyAlertWav, askLargeQtyColor, backgroundColor, bearDivAlertWav, bearishDivergenceColor, bidIcebergAlertWav, bidIcebergColor, bidLargeQtyAlertWav, bidLargeQtyColor, bullDivAlertWav, bullishDivergenceColor, columnSpacing, currentColor, depthMult, divAlertMin, divergenceAlert, downTickColor, dType, iceberAlertMinQty, icebergAlert, largeQtyAlert, largeQtyMin, leastSignificantDigits, numRows, plotDivergence, plotIceberg, plotLargeQty, textFont, upTickColor);
        }

        /// <summary>
        /// JTSummaryTape
        /// </summary>
        /// <returns></returns>
        public Indicator.JTSTape JTSTape(Data.IDataSeries input, bool alwaysOnTop, string askIcebergAlertWav, Color askIcebergColor, string askLargeQtyAlertWav, Color askLargeQtyColor, Color backgroundColor, string bearDivAlertWav, Color bearishDivergenceColor, string bidIcebergAlertWav, Color bidIcebergColor, string bidLargeQtyAlertWav, Color bidLargeQtyColor, string bullDivAlertWav, Color bullishDivergenceColor, int columnSpacing, Color currentColor, int depthMult, int divAlertMin, bool divergenceAlert, Color downTickColor, DeltaType dType, int iceberAlertMinQty, bool icebergAlert, bool largeQtyAlert, int largeQtyMin, int leastSignificantDigits, int numRows, bool plotDivergence, bool plotIceberg, bool plotLargeQty, Font textFont, Color upTickColor)
        {
            return _indicator.JTSTape(input, alwaysOnTop, askIcebergAlertWav, askIcebergColor, askLargeQtyAlertWav, askLargeQtyColor, backgroundColor, bearDivAlertWav, bearishDivergenceColor, bidIcebergAlertWav, bidIcebergColor, bidLargeQtyAlertWav, bidLargeQtyColor, bullDivAlertWav, bullishDivergenceColor, columnSpacing, currentColor, depthMult, divAlertMin, divergenceAlert, downTickColor, dType, iceberAlertMinQty, icebergAlert, largeQtyAlert, largeQtyMin, leastSignificantDigits, numRows, plotDivergence, plotIceberg, plotLargeQty, textFont, upTickColor);
        }

        /// <summary>
        /// JTSummaryTape Depth
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.JTStapeDepth JTStapeDepth(bool alwaysOnTop, Color backgroundColor, Color currentColor, Color downTickColor, int leastSignificantDigits, int numRows, Font textFont, Color upTickColor)
        {
            return _indicator.JTStapeDepth(Input, alwaysOnTop, backgroundColor, currentColor, downTickColor, leastSignificantDigits, numRows, textFont, upTickColor);
        }

        /// <summary>
        /// JTSummaryTape Depth
        /// </summary>
        /// <returns></returns>
        public Indicator.JTStapeDepth JTStapeDepth(Data.IDataSeries input, bool alwaysOnTop, Color backgroundColor, Color currentColor, Color downTickColor, int leastSignificantDigits, int numRows, Font textFont, Color upTickColor)
        {
            return _indicator.JTStapeDepth(input, alwaysOnTop, backgroundColor, currentColor, downTickColor, leastSignificantDigits, numRows, textFont, upTickColor);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// JTRTape
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.JTRTape JTRTape(Color aboveAskBackColor, Color aboveAskColor, bool alwaysOnTop, int askPosision, Color atAskBackColor, Color atAskColor, Color atBidBackColor, Color atBidColor, Color belowBidBackColor, Color belowBidColor, Color betweenBackColor, Color betweenColor, int bidPosision, ConsolidationMode cMode, int columnSpacing, int condPosition, bool hLSession, int leastSignificantDigits, int numRows, PrintMode pMode, int pricePosition, bool reverseHighLow, long sensitivity, int sizeFilter, Color sweepAskBackColor, Color sweepAskColor, Color sweepBidBackColor, Color sweepBidColor, bool sweepColors, Font textFont, int timePosition, Algorithm useAlgorithm, int volPosition)
        {
            return _indicator.JTRTape(Input, aboveAskBackColor, aboveAskColor, alwaysOnTop, askPosision, atAskBackColor, atAskColor, atBidBackColor, atBidColor, belowBidBackColor, belowBidColor, betweenBackColor, betweenColor, bidPosision, cMode, columnSpacing, condPosition, hLSession, leastSignificantDigits, numRows, pMode, pricePosition, reverseHighLow, sensitivity, sizeFilter, sweepAskBackColor, sweepAskColor, sweepBidBackColor, sweepBidColor, sweepColors, textFont, timePosition, useAlgorithm, volPosition);
        }

        /// <summary>
        /// JTRTape
        /// </summary>
        /// <returns></returns>
        public Indicator.JTRTape JTRTape(Data.IDataSeries input, Color aboveAskBackColor, Color aboveAskColor, bool alwaysOnTop, int askPosision, Color atAskBackColor, Color atAskColor, Color atBidBackColor, Color atBidColor, Color belowBidBackColor, Color belowBidColor, Color betweenBackColor, Color betweenColor, int bidPosision, ConsolidationMode cMode, int columnSpacing, int condPosition, bool hLSession, int leastSignificantDigits, int numRows, PrintMode pMode, int pricePosition, bool reverseHighLow, long sensitivity, int sizeFilter, Color sweepAskBackColor, Color sweepAskColor, Color sweepBidBackColor, Color sweepBidColor, bool sweepColors, Font textFont, int timePosition, Algorithm useAlgorithm, int volPosition)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.JTRTape(input, aboveAskBackColor, aboveAskColor, alwaysOnTop, askPosision, atAskBackColor, atAskColor, atBidBackColor, atBidColor, belowBidBackColor, belowBidColor, betweenBackColor, betweenColor, bidPosision, cMode, columnSpacing, condPosition, hLSession, leastSignificantDigits, numRows, pMode, pricePosition, reverseHighLow, sensitivity, sizeFilter, sweepAskBackColor, sweepAskColor, sweepBidBackColor, sweepBidColor, sweepColors, textFont, timePosition, useAlgorithm, volPosition);
        }

        /// <summary>
        /// JTSummaryTape
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.JTSTape JTSTape(bool alwaysOnTop, string askIcebergAlertWav, Color askIcebergColor, string askLargeQtyAlertWav, Color askLargeQtyColor, Color backgroundColor, string bearDivAlertWav, Color bearishDivergenceColor, string bidIcebergAlertWav, Color bidIcebergColor, string bidLargeQtyAlertWav, Color bidLargeQtyColor, string bullDivAlertWav, Color bullishDivergenceColor, int columnSpacing, Color currentColor, int depthMult, int divAlertMin, bool divergenceAlert, Color downTickColor, DeltaType dType, int iceberAlertMinQty, bool icebergAlert, bool largeQtyAlert, int largeQtyMin, int leastSignificantDigits, int numRows, bool plotDivergence, bool plotIceberg, bool plotLargeQty, Font textFont, Color upTickColor)
        {
            return _indicator.JTSTape(Input, alwaysOnTop, askIcebergAlertWav, askIcebergColor, askLargeQtyAlertWav, askLargeQtyColor, backgroundColor, bearDivAlertWav, bearishDivergenceColor, bidIcebergAlertWav, bidIcebergColor, bidLargeQtyAlertWav, bidLargeQtyColor, bullDivAlertWav, bullishDivergenceColor, columnSpacing, currentColor, depthMult, divAlertMin, divergenceAlert, downTickColor, dType, iceberAlertMinQty, icebergAlert, largeQtyAlert, largeQtyMin, leastSignificantDigits, numRows, plotDivergence, plotIceberg, plotLargeQty, textFont, upTickColor);
        }

        /// <summary>
        /// JTSummaryTape
        /// </summary>
        /// <returns></returns>
        public Indicator.JTSTape JTSTape(Data.IDataSeries input, bool alwaysOnTop, string askIcebergAlertWav, Color askIcebergColor, string askLargeQtyAlertWav, Color askLargeQtyColor, Color backgroundColor, string bearDivAlertWav, Color bearishDivergenceColor, string bidIcebergAlertWav, Color bidIcebergColor, string bidLargeQtyAlertWav, Color bidLargeQtyColor, string bullDivAlertWav, Color bullishDivergenceColor, int columnSpacing, Color currentColor, int depthMult, int divAlertMin, bool divergenceAlert, Color downTickColor, DeltaType dType, int iceberAlertMinQty, bool icebergAlert, bool largeQtyAlert, int largeQtyMin, int leastSignificantDigits, int numRows, bool plotDivergence, bool plotIceberg, bool plotLargeQty, Font textFont, Color upTickColor)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.JTSTape(input, alwaysOnTop, askIcebergAlertWav, askIcebergColor, askLargeQtyAlertWav, askLargeQtyColor, backgroundColor, bearDivAlertWav, bearishDivergenceColor, bidIcebergAlertWav, bidIcebergColor, bidLargeQtyAlertWav, bidLargeQtyColor, bullDivAlertWav, bullishDivergenceColor, columnSpacing, currentColor, depthMult, divAlertMin, divergenceAlert, downTickColor, dType, iceberAlertMinQty, icebergAlert, largeQtyAlert, largeQtyMin, leastSignificantDigits, numRows, plotDivergence, plotIceberg, plotLargeQty, textFont, upTickColor);
        }

        /// <summary>
        /// JTSummaryTape Depth
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.JTStapeDepth JTStapeDepth(bool alwaysOnTop, Color backgroundColor, Color currentColor, Color downTickColor, int leastSignificantDigits, int numRows, Font textFont, Color upTickColor)
        {
            return _indicator.JTStapeDepth(Input, alwaysOnTop, backgroundColor, currentColor, downTickColor, leastSignificantDigits, numRows, textFont, upTickColor);
        }

        /// <summary>
        /// JTSummaryTape Depth
        /// </summary>
        /// <returns></returns>
        public Indicator.JTStapeDepth JTStapeDepth(Data.IDataSeries input, bool alwaysOnTop, Color backgroundColor, Color currentColor, Color downTickColor, int leastSignificantDigits, int numRows, Font textFont, Color upTickColor)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.JTStapeDepth(input, alwaysOnTop, backgroundColor, currentColor, downTickColor, leastSignificantDigits, numRows, textFont, upTickColor);
        }
    }
}
#endregion
